﻿



Public Class Form1

    Dim HV As New HuVECII          'HV: an instance of HuVECII

    '*****************************************  controling Graphics ***********************************
    Dim graphGate As Graph2018                     'define graph names to be used, This graph shows the open probability of the channel     
    Dim graphIm As Graph2018                 'This graph shows current of ion channels
    Dim graphVm As Graph2018                        'This graph shows membrane potential
    Dim graphIVcurve As Graph2018                     'the initial capacitive current
    Dim graphINaL As Graph2018                        'This graph shows membrane potential
    Dim graphICaL As Graph2018                        'This graph shows membrane potential
    Dim graphpOpen As Graph2018                        'This graph shows membrane potential

    Dim MinX1 As Double = 0                     'ms, X-axis parameters, common for all graphs.  Minimum value for the X axis
    Dim MaxX1 As Double = 5000               'ms, maximum value on the X-axis
    Dim IntervalX1 As Double = 500           'ms, interval of the grids

    Dim MinY1 As Double = -100                   'mV, Vm
    Dim MaxY1 As Double = 50.01                    'mV, Vm
    Dim IntervalY1 As Double = 10            'mV, interval of the grids

    Dim MinY2 As Double = -3 '-2.6                   'pA/pF,   
    Dim MaxY2 As Double = 2  '2.001                  'pA/pF
    Dim IntervalY2 As Double = 0.4 '1               'pA/pF

    Dim MinX3 As Double = -100                    'mV,  graph I-V curve, Abscissa
    Dim MaxX3 As Double = 20
    Dim IntervalX3 As Double = 10               'mV, interval of grids

    Dim MinY3 As Double = -1.7  '-3                  'pA/pF,  graph I-V curve , Ordinate
    Dim MaxY3 As Double = 1.7  '3.001                      'pA/pF,  graph I-V curve
    Dim IntervalY3 As Double = 0.4                'pA/pF,  graph I-V curve

    Dim MinY4 As Double = -1.0                        'pA/pF,   INaL or ICaL component
    Dim MaxY4 As Double = 0.001                  'pA/pF
    Dim IntervalY4 As Double = 0.1               'pA/pF

    Dim MinY5 As Double = -2.0                        'pA/pF,   INaL or ICaL component
    Dim MaxY5 As Double = 0.001                  'pA/pF
    Dim IntervalY5 As Double = 0.1               'pA/pF

    Dim MinY6 As Double = 0.0                        'probability,   
    Dim MaxY6 As Double = 0.501                    'probability
    Dim IntervalY6 As Double = 0.1                  'probability

    '*****************************************  controling the Experimental time ***********************************
    Dim dt As Double = 0.01                  'ms, time step for integration  by Euler Method

    Dim NumberofSweeps                      'number of repetitive sweeps
    Dim sweepTime As Double              'ms, time for a single sweep
    Dim chartTime As Double                 'ms, time for successive sweeps

    Dim Clampon As Double = 100                 'ms,  time to start the voltage clamp
    Dim Clampoff As Double = 900                 'ms ,  time to quit the voltage clamp
    Dim ontime As Double                      'ms, time to start current pulse
    Dim offtime As Double                      'ms, time to switch off the current pulse

    Dim FileName As String = "VoltageClamp"

    Dim Nvar As Integer = 3
    Dim y(Nvar) As Double

    Dim IsWrite As Boolean = False
    Dim RecordInterval As Double
    Dim RecordTime As Double            '

    Public displayscfINabg As Double = 1      'scaling factor for the display of INabg
    Public displayscfIKbg As Double = 1       'scaling factor for the display of IKabg

    Dim previousIinject As Double = 0             'Iinject applied during the previous numerical integration interval dt 
    Dim Ictr As Double = 0.05                           'ms, interval to move Vm to a Vcommand
    Dim FirstDefinition As Boolean = True
    Dim SweepN As Long = 0
    Dim Nplot As Long = 0

    Dim colX As Long = 70
    Dim rowY As Long = 10
    Dim table(colX, rowY) As Double                       'Table to calculate the apparent pO of IK1, INaL, ICaL

    Private Sub BStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbStart.Click
        '********  Just to indicate the name of this program name on the Desiner screen     This part is usually fixed *******************
        Dim appPath As String = System.Reflection.Assembly.GetExecutingAssembly().Location  '使用しているプログラムのDirectory
        TextBox1.Text = appPath                   'Print the whole directory to indicate which program is used

        '************** Analysis starts here ******************************
        cbStart.Visible = False                    'hide the start button
        If FirstDefinition = True Then
            DefineGraph()                                     'create instants of graph　　
            FirstDefinition = False
        End If

        ReadForm()                                      ' read all the values on the Form  

        graphVm.PlotPoint(sweepTime, HV.Vm, Color.Black, 1, 1)
        'HV.I2_LSM = 0.01
        'HV.Is_LSM = 0.99                '0.85, 0.45

        'Do Loop for variable Is (0.65, 0.45, 0.25) 
        graphVm.Clear()
        graphVm.DrawAxis(IntervalX1, IntervalY1, "", 10)
        graphVm.PlotLine(MinX1, 0, MaxX1, 0, Color.Black, 1)    'time axis
        graphIm.Clear()
        graphIm.DrawAxis(IntervalX1, IntervalY2, "", 10)
        graphIm.PlotLine(MinX1, 0, MaxX1, 0, Color.Black, 1)      'time axis
        graphINaL.Clear()
        graphINaL.DrawAxis(IntervalX1, IntervalY4, "", 10)
        graphINaL.PlotLine(MinX1, 0, MaxX1, 0, Color.Black, 1)      'time axis
        graphICaL.Clear()
        graphICaL.DrawAxis(IntervalX1, IntervalY5, "", 10)
        graphICaL.PlotLine(MinX1, 0, MaxX1, 0, Color.Black, 1)      'time axis
        graphpOpen.Clear()
        graphpOpen.DrawAxis(IntervalX3, IntervalY6, "", 10)

        'txtIs.Text = Format(HV.Is_LSM, "#0.###")

        Nplot = 0
        SweepN = 0

        DrawAxes()                                          'clear and rewrite the grids　　

        HV.DefaultValues()                                          'get initial parameter values of the 'Model'

        HV.Is_LSM = CDbl(txtIsINaL.Text)
        HV.I2_LSM = 0.001
        Do                                               'Do Loop for various HV.Is
            HV.Vm = -96
            Vtest = HV.Vm
            oldVm = -98
            oldIextK = -1.7

            graphVm.Clear()
            graphVm.DrawAxis(IntervalX1, IntervalY1, "", 10)
            graphVm.PlotLine(MinX1, 0, MaxX1, 0, Color.Black, 1)    'time axis
            'graphIm.Clear()
            graphINaL.Clear()
            graphINaL.DrawAxis(IntervalX1, IntervalY4, "", 10)
            graphINaL.PlotLine(MinX1, 0, MaxX1, 0, Color.Black, 1)      'time axis
            graphICaL.Clear()
            graphICaL.DrawAxis(IntervalX1, IntervalY5, "", 10)
            graphICaL.PlotLine(MinX1, 0, MaxX1, 0, Color.Black, 1)      'time axis
            Do                                      'Do Loop for individual I-V curve
                'txtIsINaL.Text = Format((HV.Is_LSM + HV.I2_LSM), "0.######0")
                txtIsINaL.Text = Format((HV.Is_LSM), "0.######0")
                HV.C_LSM = 1.0 - (HV.Is_LSM + HV.I2_LSM)
                HV.O_LSM = 0
                HV.I1_LSM = 0
                sweepTime = 0                                     'reset sweepTime　　　　            　　　
                Do                                                         'Do Loop for sweepTime　　
                    My.Application.DoEvents()                'detect any events

                    calculateIinject(sweepTime, ontime, offtime, Interval)  'determine the voltage clamp current at a given Vm
                    HV.IextK = Iinject                              'Form --> HV model
                    'HV.IextK = Iinject - HV.ICaL            'Form --> HV model

                    '**************** ModelCell()***************************
                    HV.cytSubstrateConcentrations()       'In the present version, all [ATP], [ADP] , [Pi], [CrP] etc are fixed.
                    HV.IonHomeoStasis()                          'Ca buffer and Ca diffusion between jnc-iz spaces and iz-blk space
                    HV.MembraneCurrent(Vclamp)          'individual currents at the HV.Vm
                    'HV.dVmdt = -HV.Iion - HV.IextK - HV.ICaL                '+ Iinject)        ' Voltage of condenser inside

                    HV.SRCadynamics()                            'Ca diffusion within SR, Ca flux via CaRU, Ca uptake by SERCA
                    HV.MembranePotential()                    'HV.dVmdt
                    HV.Contraction(HV.Cafree_blk)
                    HV.dIonConcdt()                                  'calculate rate of ionic concentration change in each compartment
                    HV.EulerIntegration(dt)

                    If Nplot >= 100 Then
                        graphVm.PlotPoint(sweepTime, HV.Vm, Color.Black, 1, 1)
                        graphIm.PlotPoint(sweepTime, -HV.IextK, Color.Black, 1, 1)
                        graphINaL.PlotPoint(sweepTime, HV.INaL, Color.Black, 1, 1)
                        graphICaL.PlotPoint(sweepTime, HV.I_LCC, Color.Black, 1, 1)
                        Nplot = 0
                    Else
                        Nplot += 1
                    End If

                    sweepTime += dt        'proceed with the experimental time
                Loop While sweepTime < MaxX1

                SweepN += 1
                If chkwoICaL.Checked = True Then
                    graphIVcurve.PlotPoint(Vclamp, -HV.IextK - HV.I_LCC, Color.Black, 3, 3)
                Else
                    graphIVcurve.PlotPoint(Vclamp, -HV.IextK, Color.Black, 3, 3)
                End If

                If chkCurrents.Checked = True Then
                    graphIVcurve.PlotPoint(Vclamp, HV.IK1, Color.Red, 2, 2)
                    graphIVcurve.PlotPoint(Vclamp, HV.IKr, Color.SteelBlue, 2, 2)
                    graphIVcurve.PlotPoint(Vclamp, HV.INaL, Color.Blue, 2, 2)
                    graphIVcurve.PlotPoint(Vclamp, HV.ICaL, Color.Chocolate, 2, 2)
                End If

                graphpOpen.PlotPoint(Vclamp, HV.pO_IK1, Color.Red, 3, 3)
                graphpOpen.PlotPoint(Vclamp, HV.pO_IKr, Color.SteelBlue, 3, 3)
                graphpOpen.PlotPoint(Vclamp, HV.O_LSM * 100, Color.Blue, 3, 3)
                    graphpOpen.PlotPoint(Vclamp, HV.pO_ICaL * 10, Color.Chocolate, 3, 3)


                If SweepN > 1 Then
                    If chkwoICaL.Checked = True Then
                        graphIVcurve.PlotLine(oldVm, oldIextK, Vclamp, -HV.IextK - HV.I_LCC, Color.Black, 1)
                        oldIextK = -HV.IextK - HV.I_LCC                       ' - HV.I_LCC
                    Else
                        graphIVcurve.PlotLine(oldVm, oldIextK, Vclamp, -HV.IextK, Color.Black, 1)
                        oldIextK = -HV.IextK                       ' - HV.I_LCC
                    End If

                End If
                oldVm = Vclamp

                '************************************************************************************
                Vtest += IntervalVtest
            Loop While Vtest <= 20

            If chkCurrents.Checked = True Then
                HV.Is_LSM = -1
            Else
                HV.Is_LSM -= 0.2
            End If

        Loop While HV.Is_LSM >= -0.0011




        cbStart.Visible = True                    'start button appears

    End Sub


    Public Vclamp As Double
    Public Interval As Double = 0.1
    Public Vtest As Double
    Public Vhold As Double
    Public Iinject As Double
    Public IntervalVtest As Double

    Public Sub calculateIinject(ByVal time As Double, ByVal ontime As Double, ByVal offtime As Double, ByVal Interval As Double)

        If time >= ontime And time <= offtime Then         'Vtest
            Vclamp = Vtest
        Else                                                                         'Vhold
            Vclamp = Vhold
        End If

        If Vclamp = 0 Then Vclamp = 0.1 'avoid 0 mV

        Iinject = -(Vclamp - HV.Vm) / Interval      'pA/pF,   

    End Sub

    Dim oldVm As Double
    Dim oldIextK As Double

    Private Sub PlotResults()        '  Plot points on the graphs

        graphVm.PlotPoint(sweepTime, HV.Vm, Color.Black, 1, 1)
        graphIm.PlotPoint(sweepTime, -HV.IextK, Color.Black, 1, 1)
        graphINaL.PlotPoint(sweepTime, -HV.INaL, Color.Black, 1, 1)
        graphICaL.PlotPoint(sweepTime, -HV.ICaL, Color.Black, 1, 1)

    End Sub


    Private Sub ReadForm()           ' read all the values on the Form

        Clampon = CDbl(txtClampOn.Text)       'ms, onset of the voltage clamp
        Clampoff = CDbl(txtClampOff.Text)       'ms, offset of the voltage clamp

        ontime = CDbl(TxtOnTime.Text)            'ms, onset of the voltage clamp pulse
        offtime = CDbl(TxtOffTime.Text)            'ms, offset of the voltage clamp pulse

        Vhold = CDbl(txtVhold.Text)                 'mV, holding potential
        Vtest = CDbl(txtVtest.Text)                   'mV, test potential
        IntervalVtest = 2                                    'mV, interval of Vtest

        NumberofSweeps = 1
    End Sub

    Private Sub DefineGraph()                                        ' create instances of Graph
        graphGate = New Graph2018(PBINaL, MinX1, MaxX1, MinY1, MaxY1)
        graphVm = New Graph2018(pbVmpulse, MinX1, MaxX1, MinY1, MaxY1)   'time course of Vm pulse
        graphIm = New Graph2018(pbIm, MinX1, MaxX1, MinY2, MaxY2)              'time course of Im
        graphIVcurve = New Graph2018(pbIVcurve, MinX3, MaxX3, MinY3, MaxY3)    'Current-Voltage relation

        graphINaL = New Graph2018(PBINaL, MinX1, MaxX1, MinY4, MaxY4)              'time course of INaL component
        graphICaL = New Graph2018(pbICaL, MinX1, MaxX1, MinY5, MaxY5)              'time course of ICaL component

        graphpOpen = New Graph2018(pbpOpen, MinX3, MaxX3, MinY6, MaxY6)              'time course of steady-state pOpen
    End Sub

    Private Sub DrawAxes()                                           ' draw axis
        graphVm.DrawAxis(IntervalX1, IntervalY1, "", 10)
        graphVm.PlotLine(MinX1, 0, MaxX1, 0, Color.Black, 1)    'time axis

        graphIm.DrawAxis(IntervalX1, IntervalY2, "", 10)
        graphIm.PlotLine(MinX1, 0, MaxX1, 0, Color.Black, 1)      'time axis

        graphINaL.DrawAxis(IntervalX1, IntervalY4, "", 10)
        graphICaL.DrawAxis(IntervalX1, IntervalY5, "", 10)


        graphIVcurve.DrawAxis(IntervalX3, IntervalY3, "", 10)
        graphIVcurve.PlotLine(0, MinY3, 0, MaxY3, Color.Black, 1)     'vertical line
        graphIVcurve.PlotLine(MinY3, 0, MaxY3, 0, Color.Black, 1)     'holizontal line

        graphpOpen.DrawAxis(IntervalX3, IntervalY6, "", 10)

    End Sub


    Private Sub BEnd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BEnd.Click
        End
    End Sub
End Class
